@echo off
REM ' Threshold plugin 1.0 for cacti 8.5a
REM '
REM ' Copyright 2004 Aurelio DeSimone
REM ' adesimone@ciscoconfigbuilder.com
REM ' 
REM ' Use at your own risk.  NO Warranty or Guarantee given.
REM '
REM ' Some code may have been used from other parts of cacti - copyright of Ian Berry
REM '


REM Since Windows machines generally don't have awk or grep, or any other useful apps, we'll just ask for the variables  . . .

Echo --Where is Cacti installed?
Echo --Example: C:\inetpub\wwwroot\cacti
Echo --
Set /P cactibasedir=

Echo -- What's the name of the Cacti Database?
set /p cactidbname=

Echo -- What's the cacti sql username?
set /p database_username=

Echo -- What's the password for %database_username%
set /p database_password=

if not %cactibasedir% == "" (
	if exist %cactibasedir%\poller.php (
		echo "Directory Check OK"
	) else (
		echo Cacti 8.6c not found.  Please check syntax
		pause
		exit
	)
	echo Installing into %cactibasedir%
) else (
	echo Possible error in syntax
	echo You must specify cacti root directory when prompted
	echo Example:  c:\inetpub\wwwroot\cacti

	pause
	exit
)


REM make sure we aren't installing twice

if not exist %cactibasedir%\thold (
		echo This is a new install...
	) else (
		echo An installation seems already be present.  Quitting
		pause
		exit
)

REM mysql check
echo show tables; > quit.txt
mysql %cactidbname% --user=%database_username% --password=%database_password% < quit.txt | find /C "host_template_snmp_query" > dbcon.txt
for /F %%i IN ('Type dbcon.txt') do set checkdbcon=%%i
if %checkdbcon%==1 (
	
	echo DB login OK
	
) else (

	echo "**************************************************************"
	echo "WARNING: - Database login still failed - "
	echo "You will have to import manually using 'mysql cacti < thold.sql"
	echo "**************************************************************"	
)
del quit.txt
del dbcon.txt

echo  
echo WARNING: you may want to backup files & cacti database before proceeding.
echo An uninstall script is provided to remove & restore modified files.
echo Use at your own risk.  NO Warranty or Guarantee given.
echo If you continue, you agree not to hold me liable for damages or loss of data.
echo press CTRL+C in the next 5 seconds to stop

REM sleep 6
echo 

REM backup first
echo Backing up files...
rename %cactibasedir%\data_sources.php data_sources.php.bak
rename %cactibasedir%\lib\functions.php functions.php.bak
rename %cactibasedir%\include\config_arrays.php config_arrays.php.bak
rename %cactibasedir%\include\top_header.php top_header.php.bak
rename %cactibasedir%\include\top_graph_header.php top_graph_header.php.bak

REM modify files
REM echo "Modifying files..."
REM replace "127.0.0.1" "$HOSTNAME" -- check-thold.php

REM add table
echo Adding SQL tables...


mysql %cactidbname% --user=%database_username% --password=%database_password% < thold.sql


REM install files
echo "Installing new files..."
mkdir %cactibasedir%\thold\

move check-thold.php %cactibasedir%\thold\
move parse.sh %cactibasedir%\thold\
move thold.php %cactibasedir%\
move listthold.php %cactibasedir%\
move tab_thold.gif %cactibasedir%\images\
move graph_thold.php %cactibasedir%\
move config_arrays.php %cactibasedir%\include\
move data_sources.php %cactibasedir%\
move functions.php %cactibasedir%\lib\
move top_graph_header.php %cactibasedir%\include\
move top_header.php %cactibasedir%\include\


echo "*************************************************************************************************** "
echo "WARNING: your 'Poller logging level' has been changed to 5 (debug).  "
echo "This is essential for proper operation.  Please do not change this setting."
echo " "
echo "Installation complete.  MAKE SURE YOU MODIFY YOUR SCHEDULER:"
echo "You will need to add an entry to run check-thold.php